#ifndef my_general_stuff
#define my_general_stuff

#if 0

extern "C" void * hlmalloc (size_t);
extern "C" void hlfree (void *);
extern "C" void * hlrealloc (void *, size_t);
extern "C" void * dlmalloc (size_t);
extern "C" void dlfree (void *);
extern "C" void * dlrealloc (void *, size_t);
extern "C" void * kmalloc (size_t);
extern "C" void kfree (void *);
extern "C" void * krealloc (void *, size_t);

#define USE_HL 1
#define USE_DL 0
#define USE_K 0
#define USE_MALLOC 0

#if USE_HL
#define malloc(x) hlmalloc(x)
#define free(x) hlfree(x)
#define realloc(a,b) hlrealloc(a,b)
#else
#if USE_DL
#define malloc(x) dlmalloc(x)
#define free(x) dlfree(x)
#define realloc(a,b) dlrealloc(a,b)
#endif
#endif

#if USE_K
#define malloc(x) kmalloc(x)
#define free(x) kfree(x)
#define realloc(a,b) krealloc(a,b)
#endif

#endif

 
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <memory.h>
 
#define frail_allocate(pointer_variable, type)                            \
    if ((pointer_variable = (type *)malloc(sizeof(type))) == NULL)        \
    {                                                                     \
       fprintf(stderr, "Memory allocation problem --- Aborting. \n");     \
       exit(1);                                                           \
    };
 
inline char * frail_strdup(const char * source)
{
   char * dummy;

   // For some stupid reason, strdup doesn't take a const char* as
   // an argument.
   if ((dummy = strdup((char *)source)) == NULL)
   {
      fprintf(stderr, "String memory allocation problem --- Aborting. \n");
      exit(1);
   }
   return dummy;
};
 
template <class anytype>
inline void swap(anytype & A, anytype & B)
{
   anytype Save = A; A = B; B = Save;
};
 
typedef unsigned long int UInt64;
typedef unsigned int      UInt32;
typedef unsigned char     UChar;
const UInt32 MAX_UInt32 = (UInt32)(-1);
const UInt64 MAX_UInt64 = (UInt64)(-1);
 
typedef UInt32 page_number_type;
typedef UInt32 position_type;
typedef UInt64 time_type;
 
const time_type EFFECTIVELY_NEVER = (UInt64)(-1);
 
enum boolean
{
  LOGICAL_TRUE,
  LOGICAL_FALSE
};
 
enum attempt_flag
{
  SUCCESS,
  FAILURE
};
 
enum mandate
{
   MAKE_SO,
   MAKE_NOT_SO,
   DONT_CARE,
   UNINITIALIZED
};
enum relationship
{
   LESSTHAN = -1,
   EQUAL = 0,
   GREATERTHAN = 1,
   ERROR
};
 
enum change_flag
{
   INCREASED,
   DECREASED,
   UNCHANGED
};
 
enum AVL_status
{
   LEFT_TALLER,
   BALANCED,
   RIGHT_TALLER
};
 
#endif

